#ifndef _ANIMATEDSTRING_H_
#define _ANIMATEDSTRING_H_

#include <afxwin.h>
#include <list>

enum ChipInitialMode { C_RANDOM, C_TOP, C_BOTTOM, C_RIGHT, C_LEFT, C_POINT };

#define NOTREADY -1
#define INITIAL 0
#define RUNNING 1
#define FINISHED 3

// ʂ̓`\
typedef struct {
  int moveTime;      // `܂ł̎
  int stopTime;      // ~܂Ă鎞
  int explosionTime; // 󂷊Ԃ̎
  ChipInitialMode initialMode; // ǂ̂悤ȓɂ邩̒l
} ChipsDrawing;

class Chip {
public:
  Chip() {}
  ~Chip(){}
  void SetRect(int startx,int starty, int endx, int endy){
	baserect.left = startx;
	baserect.top = starty;
	baserect.right = endx;
	baserect.bottom = endy;
  }
  RECT* GetRect(){
	return &baserect;
  }

  void SetStartPoint(int x,int y){
	startpoint.x = x;
	startpoint.y = y;
  }

  void SetEndPoint(int x,int y){
	endpoint.x = x;
	endpoint.y = y;
  }
  
  POINT* GetPoint(int per){
	if(per < 0)
	  per = 0;
	if(per > 100)
	  per = 100;
	currentpoint.x = (endpoint.x - startpoint.x)*(per/100.0) + startpoint.x;
	currentpoint.y = (endpoint.y - startpoint.y)*(per/100.0) + startpoint.y;
	return &currentpoint;
  }

private:
  RECT baserect;       // ̉摜t@Cł̈ʒu
  POINT startpoint;    // n_
  POINT endpoint;      // I_
  POINT currentpoint;
};

using namespace std;

class AnimatedString {
public:
  AnimatedString();
  ~AnimatedString();
  // rbg}bv̏s܂
  int Create(char *filename,int chipsize, RECT *screen,
			 ChipsDrawing *drawingMode);

  // w̔ԍ̃XCX܂B
  int InitSlice(int n);

  // InitSliceŎw肳ꂽ̈`悵܂
  // int percent: 100FŏIʒu
  //                0Fʒu
  int DrawSlice(HDC dc,int percent); 
  int Move(HDC dc);
  int Start();
  int GetStatus(){
	return status;
  }
  inline int IsWhite(HDC dc, int x, int y, int chipsize);
private:
  HDC sourceDc;   // rbg}bvDC
  RECT bitmapRect; // rbg}bṽTCY
  int chipSize;   // ubNƂĕ\傫
  int numSlices;  // XCX̐
  RECT *slices;   // XCX
  RECT screenRect; // \ʂ̃TCY
  ChipsDrawing *chipsDrawing;
  int status;  // ʂ̏(S) INITIAL,RUNNING,FINISHED
  int drawStatus;  // ʂ̏(X) MOVE,STOP,EXPLOSION
  int currentSlice; // ݂̃XCX
  int lapTime; // ^C
  list<Chip*> *chipList;
};
#endif
