#include "stdafx.h"
#include "Goban.h"
#include <stdio.h>
#include <string.h>

Goban::Goban()
{
  InitGoban();
}

void Goban::InitGoban()
{
  int i,j;
  for(i = 0; i < GOBAN_Y_NUM; i++)
	for(j = 0; j < GOBAN_X_NUM; j++)
	  goban[i][j] = ISHI_NONE;
}

int Goban::SetIshi(int x,int y,int turn)
{
  if(IsCorrect(x,y) == FALSE)
	return FALSE;
  
  goban[y][x] = (turn == MY_TURN ? GetMyIshi() : GetTekiIshi());
  return TRUE;
}

static char *san[] = {
  ".ooo.",
  ".o.oo.",
  ".oo.o."
};

static char *yon[] = {
  ".oooo",
  "o.ooo",
  "oo.oo",
  "ooo.o",
  "oooo."
};

static char *go[] = {
  "ooooo"
};

static char *choren[] = {
  "oooooo"
};

enum IshiVect {TATE,YOKO,NANAME_DOWN,NANAME_UP};

#define ABS(n) ((n) >= 0 ? (n) : -(n))
#define ISCORRECTSCOPE(n) ((n) >= 0 && (n) <= 14)

IshiStatus Goban::GetStatus(int x, int y, char ishi)
{
  int i;
  int count;
  /* ܕ񂾂ǂ܂ׂiAj*/
  for(i = TATE; i <= NANAME_UP; i++){
	if(IsGo(GetLine(x,y,i),ishi)){
	  if(IsChoren(GetLine(x,y,i),ishi))
		return I_CHOREN;
	  else
		return I_GO;
	}
  }

  /* l񂾂ǂׂ */
  /* ̎lΎlli̋֎j */
  count = 0;
  for(i = TATE; i <= NANAME_UP; i++){
	if(IsYon(GetLine(x,y,i),ishi))
	  count++;
  }
  if(count == 1)
	return I_YON;
  if(count > 1)
	return I_YONYON;

  /* O񂾂ǂׂ */
  /* ̎OΎOOi̋֎j */
  count = 0;
  for(i = TATE; i <= NANAME_UP; i++){
	if(IsSan(GetLine(x,y,i),ishi))
	  count++;
  }
  if(count == 1)
	return I_SAN;
  if(count > 1)
	return I_SANSAN;

  return I_NONE;
}

char* Goban::GetIshiPattern(char* str,char ishi)
{
  static char buf[16];
  char *s = buf;
  char *p = str;
  while(*p != '\0'){
	if(*p == 'o')
	  *s = ishi;
	else
	  *s = *p;
	s++;
	p++;
  }
  *s = '\0';
  return buf;
}

int Goban::IsSan(char *str,char ishi)
{
  int i;
  for(i = 0; i < sizeof(san)/sizeof(char*); i++)
	if(strstr(str,GetIshiPattern(san[i],ishi)) != NULL)
	  return TRUE;
  return FALSE;
}

int Goban::IsYon(char *str,char ishi)
{
  int i;
  for(i = 0; i < sizeof(yon)/sizeof(char*); i++)
	if(strstr(str,GetIshiPattern(yon[i],ishi)) != NULL)
	  return TRUE;
  return FALSE;
}

int Goban::IsGo(char *str,char ishi)
{
  if(strstr(str,GetIshiPattern(go[0],ishi)) != NULL)
	return TRUE;
  return FALSE;
}

int Goban::IsChoren(char *str,char ishi)
{
  if(strstr(str,GetIshiPattern(choren[0],ishi)) != NULL)
	return TRUE;
  return FALSE;
}

char* Goban::GetLine(int x, int y,int mode)
{
  // cAA΂߂̐΂̏󋵂ꎟzɃRs[܂
  static char buf[BUFSIZ];
  int i,j;
  int startx,starty;
  int endx,endy;
  int count;
  switch(mode){
  case TATE:
	for(i = 0; i < GOBAN_Y_NUM; i++)
	  buf[i] = goban[i][x];
	buf[i] = '\0';
	break;
  case YOKO:
	strcpy(buf,goban[y]);
	break;
  case NANAME_DOWN:
	startx = x - 15;
	starty = y - 15;
	endx = x + 15;
	endy = y + 15;
	count = 0;
	for(i = startx,j = starty; i < endx && j < endy; i++,j++)
	  if(ISCORRECTSCOPE(i) && ISCORRECTSCOPE(j))
		buf[count++] = goban[j][i];
	buf[count]= '\0';
	break;
  case NANAME_UP:
	startx = x - 15;
	starty = y + 15;
	endx = x + 15;
	endy = y - 15;
	count = 0;
	for(i = startx,j = starty; i < endx && j > endy; i++,j--)
	  if(ISCORRECTSCOPE(i) && ISCORRECTSCOPE(j))
		buf[count++] = goban[j][i];
	buf[count]= '\0';
	break;
  }
  return buf;
}
